rem gantt chart

create table activities( label varchar2(100), start_date date, end_date date)
/


insert into activities( label, start_date, end_date )
values( 'Functional Analysis', to_date('12-03-2001','DD-MM-YYYY'), to_date('12-11-2001','DD-MM-YYYY')) 
/
insert into activities( label, start_date, end_date )
values( 'Technical Architecture', to_date('04-05-2001','DD-MM-YYYY'), to_date('18-08-2002','DD-MM-YYYY'))
/
insert into activities( label, start_date, end_date )
values( 'Technical Design', to_date('01-12-2001','DD-MM-YYYY'), to_date('24-06-2002','DD-MM-YYYY'))
/

insert into activities( label, start_date, end_date )
values( 'Development', to_date('01-05-2002','DD-MM-YYYY'), to_date('12-10-2003','DD-MM-YYYY'))
/

insert into activities( label, start_date, end_date )
values( 'Acceptance Test', to_date('10-09-2003','DD-MM-YYYY'), to_date('22-03-2004','DD-MM-YYYY')) 
/


select label  
  ,      start_date  
  ,      end_date  
  from   activities
/


with periods as
( select label  
  ,      start_date  
  ,      end_date  
  from   activities
), limits as -- determine the earliest starting date and the latest end date to determine the overall width of the chart
( select min(start_date) period_start  
  ,      max(end_date) period_end  
  ,      80 width -- set the width as the number of characters  
  from   periods
)
select * 
from limits
/


with periods as
( select label  
  ,      start_date  
  ,      end_date  
  from   activities
), limits as -- determine the earliest starting date and the latest end date to determine the overall width of the chart
( select min(start_date) period_start  
  ,      max(end_date) period_end  
  ,      80 width -- set the width as the number of characters  
  from   periods
) 
select   lpad(label, '20')||'|' activity  
  ,        (start_date - period_start)/(period_end - period_start) * width  from_pos -- the starting position for the bar  
  ,        (end_date - period_start)/(period_end - period_start)   * width to_pos   -- the end position for the bar  
  from     periods  
  ,        limits
/



with periods as
( select label  
  ,      start_date  
  ,      end_date  
  from   activities
), limits as -- determine the earliest starting date and the latest end date to determine the overall width of the chart
( select min(start_date) period_start  
  ,      max(end_date) period_end  
  ,      80 width -- set the width as the number of characters  
  from   periods
) , bars as
( select   lpad(label, '20')||'|' activity  
  ,        (start_date - period_start)/(period_end - period_start) * width  from_pos -- the starting position for the bar  
  ,        (end_date - period_start)/(period_end - period_start)   * width to_pos   -- the end position for the bar  
  from     periods  
  ,        limits
)
  select  activity
          ||lpad('I',from_pos)
          ||rpad('-', to_pos - from_pos, '-')
		  ||'I' gantt
  from     bars
  union all
  select rpad('_',width + 22,'_') 
  from   limits
  union all
  select lpad('|',21)
         ||to_char(period_start,'DD-MON-YYYY')
         ||lpad(to_char(period_end,'DD-MON-YYYY'), width - 11)
  from   limits
/
  
  
  
alter table emp
add (firedate date)
/ 


update emp
set    firedate = hiredate + 500 * (1.1 - dbms_random.value)
/


with periods as
( select ename label  
  ,      hiredate   start_date
  ,      firedate   end_date
  from   emp
), limits as -- determine the earliest starting date and the latest end date to determine the overall width of the chart
( select min(start_date) period_start  
  ,      max(end_date) period_end  
  ,      80 width -- set the width as the number of characters  
  from   periods
) , bars as
( select   lpad(label, '20')||'|' activity  
  ,        (start_date - period_start)/(period_end - period_start) * width  from_pos -- the starting position for the bar  
  ,        (end_date - period_start)/(period_end - period_start)   * width to_pos   -- the end position for the bar  
  from     periods  
  ,        limits
)
  select  activity
          ||lpad('I',from_pos)
          ||rpad('-', to_pos - from_pos, '-')
		  ||'I' gantt
  from     bars
  union all
  select rpad('_',width + 22,'_') 
  from   limits
  union all
  select lpad('|',21)
         ||to_char(period_start,'DD-MON-YYYY')
         ||lpad(to_char(period_end,'DD-MON-YYYY'), width - 11)
  from   limits

