-- not exists

select ename
from   emp e
where  not exists ( select empno
                    from   emp s
                    where  s.mgr = e.empno
                  )

-- scalar

select ename
from   emp e
where  ( select count(*)
         from emp s
         where  s.mgr = e.empno
       ) = 0


-- minus

select ename
from   emp
minus
select m.ename
from   emp s
       join
       emp m
       on (s.mgr = m.empno)

-- listagg and instr

select ename
from   emp
where  instr( ( select listagg(mgr,',') within group (order by mgr)
                from   emp
              )
            , empno) = 0

-- hierarchical
with emp_hierarchy as
( select ename
  ,      connect_by_isleaf leaf
  from   emp
  connect
  by     prior empno = mgr
  start
  with   mgr is null
)
select ename
from   emp_hierarchy
where  leaf = 1

-- hierarchical Oracle 11g
with employees (empno, name, mgr, lev) as
( select empno, ename, mgr, 1
  from   emp
  where  mgr is null
  union all
  select e.empno, e.ename
  ,      e.mgr, m.lev + 1
  from   emp e join employees m
         on (m.empno = e.mgr)
)
SEARCH DEPTH FIRST BY mgr SET seq
, employees_with_leaf as
( select e.*
  ,      case
         when (lev - lead(lev) over (order by seq)) < 0
         then 0
         else 1
         end is_leaf
  from   employees e
)
select name
from   employees_with_leaf
where  is_leaf = 1

-- anti join
select m.ename
from   emp m
       left outer join
       emp e
       on (m.empno = e.mgr)
where  e.rowid is null


-- by Anton

select ename 
from   emp e 
where  e.empno not in ( select nvl(s.mgr,-1)
                        from   emp s
                      )
           
           
-- by Laurent Schneider

create or replace type tn as table of number(4)


SELECT DISTINCT
       CASE
       WHEN empno NOT MEMBER OF
                  CAST (
                         COLLECT (DISTINCT mgr) OVER () AS tn
                       )
       THEN ename
       END ename
FROM emp
ORDER BY 1
