create table people
( id   number(10)
, name varchar2(100)
)

insert into people (id, name) values (1,'Larry')
insert into people (id, name) values (2,'Bill')
insert into people (id, name) values (3,'Barack')
insert into people (id, name) values (4,'Mark')
insert into people (id, name) values (5,'Johan')
insert into people (id, name) values (6,'John')
insert into people (id, name) values (7,'Harry')
insert into people (id, name) values (8,'Wilma')
insert into people (id, name) values (9,'Fred')


create table connections
( from_person_id number(10)
, to_person_id   number(10)
)

insert into connections (from_person_id, to_person_id) values (1,2)
insert into connections (from_person_id, to_person_id) values (1,5)
insert into connections (from_person_id, to_person_id) values (6,9)
insert into connections (from_person_id, to_person_id) values (3,4)
insert into connections (from_person_id, to_person_id) values (1,8)
insert into connections (from_person_id, to_person_id) values (8,9)
insert into connections (from_person_id, to_person_id) values (2,7)
insert into connections (from_person_id, to_person_id) values (1,3)
insert into connections (from_person_id, to_person_id) values (4,8)

select *
from   people

select *
from   connections


with objectives as
( select 'Bill' start_person
  ,      'Barack' end_person
  from   dual
)  
, links as
( select sys_connect_by_path(to_person_name,'/')  path
  ,      level - 1 degrees_of_separation
  from   ( select from_person_id
           ,      to_person_id
           ,      f.name from_person_name
           ,      t.name to_person_name
           from   ( select from_person_id
                    ,      to_person_id
                    from   connections 
                    union all
                    select to_person_id   from_person_id
                    ,      from_person_id to_person_id
                    from   connections                     
                  )  c
                  join
                  people f
                  on (c.from_person_id = f.id)
                  join 
                  people t
                  on (c.to_person_id = t.id)
         )
         cross join
         objectives
  connect by nocycle 
              ( prior to_person_id = from_person_id
                and 
                prior to_person_name != end_person
               )
  start with (to_person_name = start_person   )  
)
select distinct
       'From '||start_person||' to '||end_person objective
,      degrees_of_separation
,      path
from   links
       cross join
       objectives
where  regexp_like( path, '('||end_person||')$')  
order
by     degrees_of_separation

         
