create table badge_registrations
( badge_id        number(6)
, swipe_timestamp timestamp default systimestamp
)


insert into badge_registrations values (5, TO_TIMESTAMP ('10-APR-2011 09:10', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('10-APR-2011 08:10', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('10-APR-2011 11:50', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('10-APR-2011 17:03', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('10-APR-2011 14:45', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('10-APR-2011 18:10', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('11-APR-2011 09:10', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('11-APR-2011 18:10', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('12-APR-2011 07:45', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('12-APR-2011 15:56', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('13-APR-2011 09:05', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('13-APR-2011 17:13', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('14-APR-2011 08:45', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (5, TO_TIMESTAMP ('14-APR-2011 17:16', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('13-APR-2011 08:05', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('13-APR-2011 17:23', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('14-APR-2011 08:45', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('14-APR-2011 16:56', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('15-APR-2011 08:05', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('15-APR-2011 11:23', 'DD-Mon-YYYY HH24:MI'));
insert into badge_registrations values (7, TO_TIMESTAMP ('15-APR-2011 13:45', 'DD-Mon-YYYY HH24:MI'));


-- find day + badge id with odd number of badge-registrations

select badge_id
,      to_char( swipe_timestamp,'DD-MM-YYYY') date_with_missing_swipes
,      count(badge_id) number_of_swipes
from   badge_registrations
having mod(count(badge_id),2)=1
group 
by     badge_id
,      to_char( swipe_timestamp,'DD-MM-YYYY')


-- worked time per day per badge_id

select badge_id
,      swipe_timestamp
,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) seq_in_day
,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) next_swipe
from   badge_registrations


-- deduplication
delete
from badge_registrations 
where rowid in ( select rowid
                 from  (select rowid, row_number() over ( partition by badge_id, swipe_timestamp
                                 order by swipe_timestamp) rn
                        from   badge_registrations
                        )
                 where rn > 1
               )


select badge_id
,      swipe_timestamp
,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) seq_in_day
,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) next_swipe
from   badge_registrations


-- durations recorded per badge_id per day
select badge_id
,      case mod(seq_in_day,2) 
       when 1
       then next_swipe - swipe_timestamp 
       end  duration_inside
,      to_char( swipe_timestamp,'DD-MM-YYYY') date_of_registration
from   (
select badge_id
,      swipe_timestamp
,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) seq_in_day
,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                    order by swipe_timestamp) next_swipe
from   badge_registrations
)

-- sum together 

select badge_id
,      date_of_registration
,      sum(duration_inside) day_time
from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      to_char( swipe_timestamp,'DD-MM-YYYY') date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
group 
by     badge_id
,      date_of_registration





rem Use our own Implementation of this requirement:
rem
rem          AmisIntervalSum
rem
rem  using the Oracle Data Cartridge


select AmisIntervalSum(duration_inside) total_duration
from   badge_registrations
.
pause

rem First step: create an object that 'implements a data cartridge interface'



CREATE OR REPLACE type AmisIntervalSumImpl as object
(
  total_interval interval day(9) to second(9), 
  static function ODCIAggregateInitialize(sctx IN OUT AmisIntervalSumImpl)
    return number,
  member function ODCIAggregateIterate(self IN OUT AmisIntervalSumImpl,
    value IN varchar2) return number,
  member function ODCIAggregateTerminate(self IN AmisIntervalSumImpl,
    returnValue OUT varchar2, flags IN number) return number,
  member function ODCIAggregateMerge(self IN OUT AmisIntervalSumImpl,
    ctx2 IN AmisIntervalSumImpl) return number
);
/

rem Then, implement the Object's Body. It must implement functions Initialize, Iterate and Terminate
pause

CREATE OR REPLACE type body AmisIntervalSumImpl is
static function ODCIAggregateInitialize(sctx IN OUT AmisIntervalSumImpl)
return number is
begin
  sctx := AmisIntervalSumImpl(numtodsinterval( 0, 'SECOND' ));
  return ODCIConst.Success;
end;

member function ODCIAggregateIterate(self IN OUT AmisIntervalSumImpl, value IN varchar2) 
return number 
is
  l_value interval day(9) to second(9);
begin
  l_value := value;
  self.total_interval := self.total_interval + l_value;
  return ODCIConst.Success;
end;

member function ODCIAggregateTerminate(self IN AmisIntervalSumImpl
, returnValue OUT varchar2, flags IN number) return number is
begin
  returnValue := self.total_interval;
  return ODCIConst.Success;
end;

member function ODCIAggregateMerge(self IN OUT AmisIntervalSumImpl, ctx2 IN AmisIntervalSumImpl) 
return number 
is
begin
  self.total_interval := self.total_interval + ctx2.total_interval;
  return ODCIConst.Success;
end;
end;
/

rem Now create a function AmisIntervalSum that wraps the Object Aggregating Capabilites
pause

CREATE OR REPLACE 
FUNCTION AmisIntervalSum 
(input varchar2 ) 
RETURN varchar2
PARALLEL_ENABLE AGGREGATE USING AmisIntervalSumImpl
;

rem Now we are all set to SUM interval values:

rem find the total experience for each department

select deptno
,      AmisIntervalSum(systimestamp - hiredate ) total_experience_per_dept
from   emp
group
by     deptno
/


select deptno
,      extract(DAY from to_dsinterval
                  (AmisIntervalSum(systimestamp - hiredate ))
              ) total_experience_per_dept
from   emp
group
by     deptno
/

pause



select badge_id
,      date_of_registration
,      AmisIntervalSum(duration_inside) day_time
from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      to_char( swipe_timestamp,'DD-MM-YYYY') date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
group 
by     badge_id
,      date_of_registration


with daily_entries as
( select badge_id
,      date_of_registration
,      AmisIntervalSum(duration_inside) day_time
from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      to_char( swipe_timestamp,'DD-MM-YYYY') date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
group 
by     badge_id
,      date_of_registration
)
select badge_id
,      date_of_registration
,      day_time
from   daily_entries



-- one step before the final timesheet

with daily_entries as
( select badge_id
  ,      date_of_registration
  ,      to_dsinterval(AmisIntervalSum(duration_inside)) day_time
  from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      trunc( swipe_timestamp) date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
  group 
  by     badge_id
  ,      date_of_registration
)
select badge_id
,      to_char(date_of_registration, 'WW') weekno
,      case to_char(date_of_registration,'D') when '1' then day_time end monday
,      case to_char(date_of_registration,'D') when '2' then day_time end tuesday
,      case to_char(date_of_registration,'D') when '3' then day_time end wednesday
,      case to_char(date_of_registration,'D') when '4' then day_time end thursday
,      case to_char(date_of_registration,'D') when '5' then day_time end friday
from   daily_entries






-- classic pivot (pre 11g)
with daily_entries as
( select badge_id
  ,      date_of_registration
  ,      to_dsinterval(AmisIntervalSum(duration_inside)) day_time
  from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      trunc( swipe_timestamp) date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
  group 
  by     badge_id
  ,      date_of_registration
)
select badge_id
,      to_char(date_of_registration, 'WW') weekno
,      to_dsinterval(AmisIntervalSum(case to_char(date_of_registration,'D') when '1' then day_time end)) monday
,      to_dsinterval(AmisIntervalSum(case to_char(date_of_registration,'D') when '2' then day_time end)) tuesday
,      to_dsinterval(AmisIntervalSum(case to_char(date_of_registration,'D') when '3' then day_time end)) wednesday
,      to_dsinterval(AmisIntervalSum(case to_char(date_of_registration,'D') when '4' then day_time end)) thursday
,      to_dsinterval(AmisIntervalSum(case to_char(date_of_registration,'D') when '5' then day_time end)) friday
from   daily_entries
group by badge_id, to_char(date_of_registration, 'WW')



-- modern pivot
with daily_entries as
( select badge_id
,      date_of_registration
,      AmisIntervalSum(duration_inside) day_time
from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      trunc( swipe_timestamp) date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, to_char( swipe_timestamp,'DD-MM-YYYY')
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
group 
by     badge_id
,      date_of_registration
)
select *
from (  select to_number(to_char(date_of_registration,'D')) day_of_week
        ,      day_time
        ,      badge_id
        from (   select badge_id
                 ,      date_of_registration
                 ,      day_time
                 from   daily_entries  
             )
      ) pivot ( max(to_dsinterval(day_time))
                for day_of_week in ( '1' Monday,'2' Tuesday, '3' Wednesday
                                   , '4' Thursday, '5' Friday)
              )  


-- rollup: totals per badge per day, week, month

with daily_entries as
( select badge_id
,      to_char(date_of_registration, 'WW') week
,      date_of_registration
,      AmisIntervalSum(duration_inside) day_time
from ( select badge_id
       ,      case mod(seq_in_day,2) 
              when 1
              then next_swipe - swipe_timestamp 
              end  duration_inside
       ,      trunc( swipe_timestamp) date_of_registration
       from   ( select badge_id
                ,      swipe_timestamp
                ,      row_number() over ( partition by badge_id, trunc( swipe_timestamp)
                                           order by swipe_timestamp) seq_in_day
                ,      lead(swipe_timestamp) over ( partition by badge_id, trunc( swipe_timestamp)
                                                    order by swipe_timestamp) next_swipe
                from   badge_registrations
               )
     )
group 
by     rollup( badge_id
             ,      to_char(date_of_registration, 'WW')
             ,      date_of_registration
             )
)
select badge_id
,      week
,      date_of_registration
,      24*extract(day from to_dsinterval(day_time)) + extract(hour from to_dsinterval(day_time))  time
from   daily_entries
