-- letters not used in any Employee Name

with alphabet as
( select chr(64+rownum) letter
  from   dual
  connect
  by     rownum < 27
)
select letter
from   alphabet
       left outer join
       emp
       on instr( ename, letter ) > 0
where  emp.rowid is null



with alphabet as
( select chr(64+rownum) letter
  from   dual
  connect
  by     rownum < 27
)
, employeenames as
( select listagg(ename,',') within group (order by sal) enames
  from   emp
)
select letter
from   alphabet
       cross join
       employeenames
where  instr( enames, letter ) = 0




with alphabet as
( select chr(64+rownum) letter
  from   dual
  connect
  by     rownum < 27
)
, employeenames as
( select listagg(ename,',') within group (order by sal) enames
  from   emp
)
,  ename_letters as
( select substr(enames, level, 1) letter
  from   employeenames
  connect
  by     level <= length(enames)
)
select letter
from   alphabet
minus
select letter
from   ename_letters


-- by Laurent

select translate( 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
                ,'@'|| listagg(ename) within group(order by 1)
                ,'@') 
from emp


-- Jobs NOT in the department

select distinct
       deptno
,      position
from   emp
       partition by (deptno)
       right outer join
       ( select distinct job position
         from   emp
       )  functions
       on (emp.job = functions.position)
where  emp.rowid is null
order
by     deptno
,      position

-- in a CSV list
select deptno
,      listagg(position, ',') within group (order by position) unfilled_jobs
from ( select deptno
       ,      position
       from   emp
              partition by (deptno)
              right outer join
              ( select distinct job position
                from   emp
              )  functions
              on (emp.job = functions.position)
       where  emp.rowid is null
     )
group
by     deptno
order
by     deptno


-- in which month was no one hired

with months as
( select 0 + rownum month_num
  ,      to_char( to_date('01-'||rownum||'-2010', 'DD-MM-YYYY'), 'MONTH') month_name
  from   dual
  connect
  by     level < 13
)
select months.month_name
from   emp e
       right outer join
       months
       on extract(month from e.hiredate)= months.month_num
where  e.rowid is null
order
by     months.month_num


-- numbers of hires per department, per month (including months in which no one was hired

with months as
( select 0 + rownum month_num
  ,      to_char( to_date('01-'||rownum||'-2010', 'DD-MM-YYYY'), 'MONTH') month_name
  from   dual
  connect
  by     level < 13
)
select months.month_name
,      deptno department
,      count(empno) "number of hires"
from   emp e
       partition by (deptno)
       right outer join
       months
       on extract(month from e.hiredate)= months.month_num
group
by     months.month_name
,      months.month_num
,      deptno
order
by     months.month_num
,      deptno
